'ﾏﾄﾘｯｸｽﾃﾞｰﾀ計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class FEM3VRCal3a
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(184, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "質量マトリックスの計算"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 232)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(336, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(128, 168)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'FEM3VRCal3a
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(432, 278)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.PictureBox1, Me.ProgressBar1, Me.Label3, Me.Label2, Me.Label1})
        Me.Name = "FEM3VRCal3a"
        Me.Text = "FEM3VRCal3a"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim Nbound As Integer       '拘束の全節点数

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim Jdirect(,) As Integer   '拘束全節点の各軸方向拘束有無(0:非拘束、1:拘束）
    Dim Nrest() As Integer      '拘束の全節点番号

    Dim Em() As Single          '要素の質量ﾏﾄﾘｯｸｽ計算の配列
    Dim Vdirect(,) As Single    '拘束全節点の各変位方向拘束値

    Private Sub CoeffMatrix(ByVal ie As Integer, ByVal rou As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'rou･･･材料の密度
        Dim i, i1, i2, i3, ig, jg, kg, numg As Integer
        Dim b1, b2, dv, ratio, s, sumdiag, t, totalmass, u As Single
        Dim dj As Double

        numg = 0
        totalmass = 0   '要素質量合計
        sumdiag = 0     '行列対角の積分質量合計
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    b1 = rou * dv
                    totalmass = totalmass + b1
                    For i = 1 To 20
                        i1 = 3 * i - 2
                        i2 = i1 + 1
                        i3 = i1 + 2
                        b2 = b1 * Shape(i) * Shape(i)
                        sumdiag = sumdiag + b2
                        Em(i1) = Em(i1) + b2
                        Em(i2) = Em(i2) + b2
                        Em(i3) = Em(i3) + b2
                    Next i
                Next kg
            Next jg
        Next ig

        '要素質量合計の補正
        ratio = totalmass / sumdiag
        For i = 1 To 20
            i1 = 3 * i - 2
            i2 = i1 + 1
            i3 = i1 + 2
            Em(i1) = Em(i1) * ratio
            Em(i2) = Em(i2) * ratio
            Em(i3) = Em(i3) * ratio
        Next i

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByRef kb As Integer, _
        ByRef rou As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kb･･･材料番号
        'rou･･･材料の密度
        Dim i, id, ii, j, k, kp, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        kp = NumMat(ie)
        If kp <> kb Then
            kb = kp
            rou = RouMat(kp)
        End If

        For i = 1 To Nvar
            Em(i) = 0
        Next i

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            k = Ndim * (i - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = Lcomp(k)
            Next id
        Next ii

        If KindElem = 0 Then
            Call CoeffMatrix(ie, rou)  '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ic, id, ie, j, jmax, k, kb, nb As Integer

        If KindElem = 0 Then
            Nvar = 60
            jmax = 8
        End If
        Nstress = 6
        Nall = Ndim * Npoint

        ReDim NPrefer(Nvar)
        ReDim Em(Nvar)
        ReDim KdispMatR(Nall), NodeMatR(Nall)

        If Kboundfree = 0 Then
            '拘束ﾃﾞｰﾀの処理
            nb = NboundP
            If NboundS > 0 Then
                nb = nb + jmax * NboundS
            End If
            If nb > 0 Then
                Dim nrp(nb), jfix(nb, Ndim) As Integer
                Dim vfix(nb, Ndim) As Single
                k = 0
                If NboundP > 0 Then
                    For i = 1 To NboundP
                        k = k + 1
                        nrp(k) = NrestP(i)
                        For id = 1 To Ndim
                            jfix(k, id) = JdirectP(i, id)
                            vfix(k, id) = VdirectP(i, id)
                        Next id
                    Next i
                End If
                If NboundS > 0 Then
                    Dim kbuf(8) As Integer
                    For i = 1 To NboundS
                        ie = KBsurf(i, 1)
                        kb = KBsurf(i, 2)
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, kb, kbuf)   '面の設定
                        End If
                        For j = 1 To jmax
                            k = k + 1
                            nrp(k) = kbuf(j)
                            For id = 1 To Ndim
                                jfix(k, id) = JdirectS(i, id)
                                vfix(k, id) = VdirectS(i, id)
                            Next id
                        Next j
                    Next i
                End If
                '節点重複の削除･･･最大採用
                For i = 1 To nb
                    For j = i + 1 To nb
                        If nrp(i) = nrp(j) Then
                            For id = 1 To Ndim
                                If jfix(j, id) > 0 Then
                                    ic = 0
                                    If jfix(i, id) = 0 Then
                                        ic = 1
                                    ElseIf vfix(j, id) > vfix(i, id) Then
                                        ic = 1
                                    End If
                                    If ic > 0 Then
                                        jfix(i, id) = 1
                                        vfix(i, id) = vfix(j, id)
                                    End If
                                End If
                            Next id
                            nrp(j) = 0
                        End If
                    Next j
                Next i
                '拘束条件を新規保存（節点番号順）
                Nbound = 0
                For i = 1 To nb
                    If nrp(i) > 0 Then
                        Nbound = Nbound + 1
                    End If
                Next i
                ReDim Nrest(Nbound), Jdirect(Nbound, Ndim), Vdirect(Nbound, Ndim)
                For i = 1 To Nbound
                    ic = 0
                    For j = 1 To nb
                        If nrp(j) > 0 Then
                            If ic = 0 Then
                                k = j
                                ic = 1
                            ElseIf nrp(j) < nrp(k) Then
                                k = j
                            End If
                        End If
                    Next j
                    Nrest(i) = nrp(k)
                    For id = 1 To Ndim
                        Jdirect(i, id) = jfix(k, id)
                        Vdirect(i, id) = vfix(k, id)
                    Next id
                    nrp(k) = 0
                Next i
            End If
        End If

        '縮小ﾏﾄﾘｯｸｽの設定
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i
        If Kboundfree = 0 Then
            If Nbound > 0 Then
                For i = 1 To Nbound
                    k = Ndim * (Nrest(i) - 1)
                    For j = 1 To Ndim
                        If Jdirect(i, j) > 0 Then
                            Lcomp(k + j) = 0
                        End If
                    Next j
                Next i
            End If
        End If
        nb = 0
        For i = 1 To Npoint     '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            k = Ndim * (i - 1)
            For j = 1 To Ndim
                k = k + 1
                If Lcomp(k) > 0 Then
                    nb = nb + 1
                    Lcomp(k) = nb
                    NodeMatR(nb) = i
                    KdispMatR(nb) = j
                End If
            Next
        Next
        ReDim RMmatrix(nb)
        Norder = nb

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1)
        WeightG(2) = 0.88888889

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
     ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it As Integer

        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                RMmatrix(it) = RMmatrix(it) + Em(i)
            End If
        Next i

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub FEM3VRCal3a_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, fxb$, timn$
        Dim ic, icount, ie, ix, kb As Integer
        Dim df, fwx, rdif, rmesh, rmeshsum, rou, sec As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        fxb$ = ""
        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100
        fwx = 0

        df = Fw2 / Nelem
        rmeshsum = Nelem   'ﾒｯｼｭ合計

        Call InitialSet1()  '初期設定

        kb = 0
        ic = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie, kb, rou)    '要素ﾏﾄﾘｯｸｽの計算
            Call Store()                    '全体ﾏﾄﾘｯｸｽへの蓄積

            '進行表示
            fwx = fwx + df
            ProgressBar1.Value = fwx

            If ic = 9 Then
                rmesh = ie
                Dim timenew As Date = Now
                sec = TimeLap(Timst, timenew)
                rdif = rmeshsum - rmesh
                Call ReqTime(rmesh, rdif, sec)     '残りの所要時間の計算
                ic = 0
            Else
                ic = ic + 1
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        gr.Clear(Color.White)

        Call TimCal(1, timn$)   'ﾀｲﾏｰ計算
        aa$ = "END   " & timn$
        Label1.Text = "計算終了！"
        Label2.Text = "質量ﾏﾄﾘｯｸｽを算出しました。"
        Label3.Text = aa$

        aa$ = "質量ﾏﾄﾘｯｸｽを解析用ファイルに保存しますか？"
        Me.BringToFront()
        ix = MsgBox(aa$, 4, "ファイル保存")
        If ix = 6 Then
            KindVEqua = 0
            NPvib = 1
            NLvib = 1
            KAnal = 0
            NvibTime = 1
            ReDim KPvib(1), JLoadVib(1, 3)
            ReDim FLvibTime(1, 1)
            KindLvib = 0
            Call FileName(Fstruct$, fxb$)     'ﾌｧｲﾙ名から拡張子なしの部分を取得
            Fm$ = fxb$ + "VR" + ".dat"
            InOut = 1
            Dim frm As Form = New AnalDat6() 'ﾌｧｲﾙへの保存
            frm.Show()
        End If
        Me.Close()

    End Sub
End Class
