'ＭＫ型およびＭＣＫ型の振動応答計算実行ﾌﾟﾛｸﾞﾗﾑ（ｽｶｲﾗｲﾝ法）
'縮小ﾏﾄﾘｯｸｽ方式採用
Imports System.Drawing

Public Class FEM3VRCal4
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(240, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "振動応答計算の実行（スカイライン法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(112, 200)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(184, 24)
        Me.PictureBox2.TabIndex = 3
        Me.PictureBox2.TabStop = False
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(112, 144)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(248, 24)
        Me.PictureBox1.TabIndex = 4
        Me.PictureBox1.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(56, 256)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(384, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'FEM3VRCal4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "FEM3VRCal4"
        Me.Text = "FEM3VRCal4"
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim KindTime As Integer         '丸め区分（0:1以上、1:1未満）
    Dim KVibOff As Integer          '加振解除の有無（0:なし、1:有り）
    Dim Mband As Integer            'ﾊﾞﾝﾄﾞ幅（ﾊｰﾌ）
    Dim Nbound As Integer           '拘束の全節点数
    Dim NbTime As Integer           '計算時間の丸め位置の桁数
    Dim NBvar As Integer            '固定の変数の数
    Dim Neff As Integer             '縮小ﾏﾄﾘｯｸｽの行列数
    Dim NumEff As Integer           'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数

    Dim Beta As Single              'NewMark法の係数β
    Dim Cmax As Single              'Ｃ行列要素の最大値
    Dim DeltaMax As Single          '最大変位（絶対値）
    Dim DeltaMaxb As Single         '前ｻｲｸﾙの最大変位（絶対値）
    Dim RKmax As Single             'Ｋ行列要素の最大値
    Dim RMmax As Single             'Ｍ行列要素の最大値

    Dim Idiag() As Integer      	'改良順FEM行列(ｽｶｲﾗｲﾝ)対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim Jdirect(,) As Integer       '拘束全節点の各軸方向拘束有無
    '                                (0:非拘束、1:拘束）
    Dim KAccSet() As Integer        '縮小行列変数の加速度設定有無
    Dim KBfix() As Integer          '固定の変数番号
    Dim KcheckP() As Integer        '縮小行列変数のﾁｪｯｸ除外有無
    Dim KCLvib() As Integer         '各振動荷重の計算変数番号 
    Dim KDispMax(3) As Integer      '最大変位の節点番号
    Dim KDispSet() As Integer       '縮小行列変数の変位設定有無
    Dim KFLvibMax(3) As Integer     '最大振動外力の節点番号
    Dim KStMax(10) As Integer       '最大応力の節点番号
    Dim Lcomp() As Integer          '改良順全変数の縮小ﾏﾄﾘｯｸｽ変数番号
    Dim Nrest() As Integer          '拘束の全節点番号
    Dim Nw() As Integer             '各節点の共通要素数

    Dim Accel0() As Double          '節点加速度の初期値
    Dim Accel1(), Accel2() As Double    '節点加速度
    Dim B(,) As Double              'Bﾏﾄﾘｯｸｽ
    Dim Cmatb() As Single           'Ｃ行列
    Dim D(,) As Double              'Dﾏﾄﾘｯｸｽ
    Dim Db(,) As Double             'DBﾏﾄﾘｯｸｽ
    Dim Disp0() As Double           '節点変位の初期値
    Dim Disp1(), Disp2() As Double  '節点変位
    Dim DispMax(3) As Single        '最大変位
    Dim Ek(,) As Double             '要素計算の２次配列
    Dim Eu() As Double              '節点変位
    Dim FLoadVib(,) As Single       '節点振動外力の各軸方向の値
    Dim FLoadVibI(,) As Single      '節点振動外力の各軸方向の開始値
    Dim FLoadVibX(,) As Single      '節点振動外力の各軸方向の使用値
    Dim FLvibMax(3) As Single       '最大振動外力
    Dim RKmatb() As Single          'Ｋ行列
    Dim RMmatb() As Single          'Ｍ行列
    Dim Sgaus(,) As Double          '要素計算のｶﾞｳｽ点応力
    Dim Spoint(,) As Double         '要素計算の節点応力
    Dim StMax(10) As Single         '最大応力
    Dim TDispMax(3) As Single       '最大変位の時刻
    Dim TfD() As Double             'FEM計算の右辺ベクトル
    Dim TFLvibMax(3) As Single      '最大振動外力の時刻
    Dim TfS() As Single             '静解析の変位
    Dim Tk() As Double              'FEM行列
    Dim Tp(,) As Double             '節点応力累積値
    Dim Tr(20, 27) As Single        '節点応力計算ﾏﾄﾘｯｸｽ
    Dim TStMax(10) As Single        '最大応力の時刻
    Dim VBfix() As Double           '変数固定値
    Dim Vdirect(,) As Single        '拘束全節点の各変位方向拘束値
    Dim Vel0() As Double            '節点速度の初期値
    Dim Vel1(), Vel2() As Double    '節点速度

    Private Sub AccelCalc(ByVal mh As Integer)
        '加速度の計算
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ib, k, k2 As Integer
        Dim ub As Single
        Dim b1, b2, c1 As Double

        If KindVEqua = 1 Then
            c1 = 0.5 * DTime
            If KindDamp = 1 And Ndamp = 0 Then
                For i = 1 To Norder
                    b1 = Cmatb(Idiag(i)) * (Vel1(i) + c1 * Accel1(i))
                    TfD(i) = TfD(i) - b1
                Next i
            Else
                For i = 1 To Norder
                    b1 = 0
                    For k = Idiag(i - 1) + 1 To Idiag(i)
                        ib = i - (Idiag(i) - k)
                        b1 = b1 + Cmatb(k) * (Vel1(ib) + c1 * Accel1(ib))
                    Next k
                    If i < Norder Then
                        k2 = i + mh - 1
                        If k2 > Norder Then
                            k2 = Norder
                        End If
                        For k = i + 1 To k2
                            ib = Idiag(k) - k + i
                            If ib > Idiag(k - 1) Then
                                b1 = b1 + Cmatb(ib) * (Vel1(k) + c1 * Accel1(k))
                            End If
                        Next k
                    End If
                    TfD(i) = TfD(i) - b1
                Next i
            End If

        End If

        c1 = (0.5 - Beta) * DTime * DTime
        For i = 1 To Norder
            b1 = 0
            For k = Idiag(i - 1) + 1 To Idiag(i)
                ib = i - (Idiag(i) - k)
                b2 = Disp1(ib) + DTime * Vel1(ib) + c1 * Accel1(ib)
                b1 = b1 + RKmatb(k) * b2
            Next k
            If i < Norder Then
                k2 = i + mh - 1
                If k2 > Norder Then
                    k2 = Norder
                End If
                For k = i + 1 To k2
                    ib = Idiag(k) - k + i
                    If ib > Idiag(k - 1) Then
                        b2 = Disp1(k) + DTime * Vel1(k) + c1 * Accel1(k)
                        b1 = b1 + RKmatb(ib) * b2
                    End If
                Next k
            End If
            TfD(i) = TfD(i) - b1
        Next i

        Call TKmatSet() 'TK行列設定

        If KindLvib = 1 And KVibOff = 0 Then
            For i = 1 To NLvib
                k = KCLvib(i)
                ub = Accel2(k)
                Call RestCond(k, Mband, Norder, ub)   '拘束条件処理
            Next i
        End If

        Call Solver1(Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

        Call Solver2(Mband, Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

        For i = 1 To Norder
            If KAccSet(i) = 0 Then
                Accel2(i) = TfD(i)
            End If
        Next i

    End Sub

    Private Sub AccelInit()
        '初期加速度の計算
        Dim aa$
        Dim i, nx As Integer
        Dim b1 As Single
        nx = Norder
        Dim buf(nx) As Single

        For i = 1 To nx
            b1 = RMmatb(i)
            If b1 <= 0 Then
                aa$ = "質量マトリックスが正でありません！"
                MsgBox(aa$, 0, "データエラー")
                End
            End If
            buf(i) = 1 / b1
        Next i
        For i = 1 To nx
            Accel2(i) = buf(i) * TfD(i)
        Next

    End Sub

    Private Sub AccelPointSet()
        '加速度加振点の設定
        Dim ii, ix, jx, k, nb As Integer
        ReDim KCLvib(NLvib)

        nb = 0
        For ix = 1 To NPvib
            ii = Ndim * (KPvib(ix) - 1)
            For jx = 1 To Ndim
                If JLoadVib(ix, jx) > 0 Then
                    k = Lcomp(ii + jx)
                    If k > 0 Then
                        nb = nb + 1
                        KCLvib(nb) = k
                    End If
                End If
            Next jx
        Next ix

    End Sub

    Private Sub BMatrix()
        '変位を歪に変換するﾏﾄﾘｯｸｽの計算
        Dim i, ii, isb, j, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For isb = 1 To Nstress
            For i = 1 To Nvar
                B(isb, i) = 0
            Next i
        Next isb
        For ii = 1 To nmax
            j = Ndim * (ii - 1)
            B(1, j + 1) = Dx(ii)
            B(2, j + 2) = Dy(ii)
            B(3, j + 3) = Dz(ii)
            B(4, j + 1) = Dy(ii)
            B(4, j + 2) = Dx(ii)
            B(5, j + 2) = Dz(ii)
            B(5, j + 3) = Dy(ii)
            B(6, j + 1) = Dz(ii)
            B(6, j + 3) = Dx(ii)
        Next ii

    End Sub

    Private Sub CmatSet()
        'Ｃ行列設定
        Dim i, ii, j, jj, k As Integer
        ReDim Cmatb(NumEff)

        If KindDamp = 0 Then
            For i = 1 To NumEff
                Cmatb(i) = CoeffK * RKmatb(i)
            Next i
            For j = 1 To Norder
                k = Idiag(j)
                Cmatb(k) = Cmatb(k) + CoeffM * RMmatb(j)
            Next j
        Else
            ii = 0
            For i = 1 To Npoint
                k = Ndim * (Kcomp(i) - 1)
                For j = 1 To Ndim
                    k = k + 1
                    jj = Lcomp(k)
                    If jj > 0 Then
                        ii = ii + 1
                        Cmatb(Idiag(jj)) = Cmatrix(ii)
                    End If
                Next j
            Next i
        End If
        If Ndamp > 0 Then
            Call DampSet()      'ﾀﾞﾝﾊﾟｰの設定
        End If

    End Sub

    Private Sub CoeffMatrix(ByVal ie As Integer, ByVal istage As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･ｶﾞｳｽ点応力計算の有無（0:なし、1:有り）
        Dim i, id, ig, ii, isb, j, jg, kg, kkg, numg As Integer
        Dim dv, s, t, u As Single
        Dim dj As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    Call BMatrix()
                    For isb = 1 To Nstress
                        For i = 1 To Nvar
                            Db(isb, i) = 0
                            For j = 1 To Nstress
                                Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                            Next j
                        Next i
                        If istage > 0 Then
                            Sgaus(numg, isb) = 0 : kkg = 0
                            For ii = 1 To 20
                                For id = 1 To Ndim
                                    kkg = kkg + 1
                                    Sgaus(numg, isb) = Sgaus(numg, isb) + Db(isb, kkg) * Eu(kkg)
                                Next id
                            Next ii
                        End If
                    Next isb

                    If istage = 0 Then
                        For i = 1 To Nvar
                            For j = i To Nvar
                                For isb = 1 To Nstress
                                    Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * dv
                                Next isb
                            Next j
                        Next i
                    End If
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub ConvResult(ByVal iconv As Integer, ByVal ik As Integer)
        '収束結果の出力
        'iconv･･･収束経緯（0:初、1:済み）
        'ik･･･繰返し計算回数
        Dim aa$, ad$
        Dim b1 As Single

        ad$ = "-------------------------------------------------------"
        b1 = Math.Abs(DeltaMax - DeltaMaxb)
        SwK.WriteLine(ad$)
        If iconv = 0 Then
            aa$ = "収束繰返し回数" + "," + Str(ik)
        Else
            aa$ = "繰返し回数" + "," + Str(ik)
        End If
        SwK.WriteLine(aa$)
        aa$ = "旧変位、新変位、差" + "," + Str(DeltaMaxb) + ","
        aa$ = aa$ + Str(DeltaMax) + "," + Str(b1)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub DampSet()
        'ﾀﾞﾝﾊﾟｰの設定
        Dim i, j, k, k1, k2, kb, kk, kx As Integer
        Dim b1, b2, cb As Single
        Dim k1buf(3), k2buf(3) As Single
        Dim acos(3), aval1(3), aval2(3) As Single

        For i = 1 To Ndamp
            k1 = KPdamp(i, 1)
            aval1(1) = Xdata(k1)
            aval1(2) = Ydata(k1)
            aval1(3) = Zdata(k1)
            k2 = KPdamp(i, 2)
            If k2 > 0 Then
                aval2(1) = Xdata(k2)
                aval2(2) = Ydata(k2)
                aval2(3) = Zdata(k2)
            Else
                aval2(1) = DataDamp(i, 1)
                aval2(2) = DataDamp(i, 2)
                aval2(3) = DataDamp(i, 3)
            End If
            Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
            cb = DataDamp(i, 4)
            kb = Ndim * (Kcomp(k1) - 1)
            For j = 1 To 3
                k1buf(j) = Lcomp(kb + j)
            Next j
            For k = 1 To 3
                kk = k1buf(k)
                If kk > 0 Then
                    b1 = acos(k) * cb
                    For j = k To 3
                        kb = k1buf(j)
                        If kb > 0 Then
                            kx = Idiag(kb) - kb + kk
                            Cmatb(kx) = Cmatb(kx) + b1 * acos(j)
                        End If
                    Next j
                End If
            Next k
            If k2 > 0 Then
                kb = Ndim * (Kcomp(k2) - 1)
                For j = 1 To 3
                    k2buf(j) = Lcomp(kb + j)
                Next j
                For k = 1 To 3
                    kk = k2buf(k)
                    If kk > 0 Then
                        b1 = acos(k) * cb
                        For j = k To 3
                            kb = k2buf(j)
                            If kb > 0 Then
                                kx = Idiag(kb) - kb + kk
                                Cmatb(kx) = Cmatb(kx) + b1 * acos(j)
                            End If
                        Next j
                        For j = k To 3
                            kb = k1buf(j)
                            If kb > 0 Then
                                b2 = b1 * acos(j)
                                If kb > kk Then
                                    kx = Idiag(kb) - kb + kk
                                Else
                                    kx = Idiag(kk) - kk + kb
                                End If
                                Cmatb(kx) = Cmatb(kx) - b2
                            End If
                        Next j
                    End If
                Next k
            End If
        Next i

    End Sub

    Private Sub DispCalc()
        '変位の計算
        Dim i As Integer
        Dim b1, c1, c2 As Double

        c1 = 0.5 * DTime
        For i = 1 To Norder
            If KDispSet(i) = 0 Then
                Vel2(i) = Vel1(i) + c1 * (Accel1(i) + Accel2(i))
            End If
        Next i
        c1 = (0.5 - Beta) * DTime * DTime
        c2 = Beta * DTime * DTime
        For i = 1 To Norder
            If KDispSet(i) = 0 Then
                b1 = Disp1(i) + DTime * Vel1(i)
                Disp2(i) = b1 + c1 * Accel1(i) + c2 * Accel2(i)
            End If
        Next i

    End Sub

    Private Sub DispCheck()
        '変位のﾁｪｯｸ
        Dim i As Integer
        Dim b1, b2 As Single
        b1 = 0
        For i = 1 To Norder
            If KcheckP(i) = 0 Then
                b2 = Math.Abs(Disp2(i))
                If b2 > b1 Then
                    b1 = b2
                End If
            End If
        Next i
        If b1 > DeltaMax Then
            DeltaMax = b1
        End If

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer, _
        ByRef kb As Integer, ByRef e As Single, ByRef rnu As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･ｶﾞｳｽ点応力計算の有無（0:なし、1:有り）
        'kb･･･材料番号
        'e･･･ﾔﾝｸﾞ率
        'rnu･･･ﾎﾟｱｿﾝ比
        Dim i, id, ii, j, k, kp, nmax As Integer
        Dim b0, b1, b2, b3 As Single

        If KindElem = 0 Then
            nmax = 20
        End If
        kp = NumMat(ie)
        If kp <> kb Then
            For i = 1 To Nstress
                For j = 1 To Nstress
                    D(i, j) = 0
                Next j
            Next i
            kb = kp
            e = DataMat(kp, 1)
            rnu = DataMat(kp, 2)

            '歪から応力を換算するﾏﾄﾘｯｸｽ成分の計算
            b0 = e / ((1 + rnu) * (1 - 2 * rnu))
            b1 = b0 * (1 - rnu)
            b2 = b0 * rnu
            b3 = e / (2 * (1 + rnu))
            D(1, 1) = b1 : D(2, 2) = b1 : D(3, 3) = b1
            D(1, 2) = b2 : D(1, 3) = b2
            D(2, 1) = b2 : D(2, 3) = b2
            D(3, 1) = b2 : D(3, 2) = b2
            D(4, 4) = b3 : D(5, 5) = b3 : D(6, 6) = b3
        End If

        For i = 1 To Nvar
            For j = 1 To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = Lcomp(k)
            Next id
        Next ii

        If KindElem = 0 Then
            Call CoeffMatrix(ie, istage)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub EquaCalc(ByVal cbuf() As Single, ByRef xanswer As Single, _
        ByVal xleft As Single, ByVal xright As Single)
        '主応力の3次方程式の計算（Regular Falsi法）
        'cbuf()･･･係数
        'xanswer･･･方程式の解（最初は初期値）
        'xleft･･･変数区間の下限値
        'xright･･･変数区間の上限値
        Dim iter, itermax As Integer
        Dim b1, epsf, fanswer, fleft, fright As Single
        fanswer = EquaValue(cbuf, xanswer)
        epsf = Math.Abs(fanswer) * 0.000001
        itermax = 100            '繰返し計算の打切り回数
        iter = 0

        Do
            fleft = EquaValue(cbuf, xleft)       'X下限値に対する関数値
            fright = EquaValue(cbuf, xright)     'X上限値に対する関数値

            b1 = fright - fleft
            If b1 = 0 Then
                xanswer = xleft
                Exit Do
            End If
            xanswer = (xleft * fright - xright * fleft) / b1
            fanswer = EquaValue(cbuf, xanswer)

            If fanswer * fright > 0 Then
                xright = xanswer
            Else
                xleft = xanswer
            End If
            iter = iter + 1
        Loop Until Math.Abs(fanswer) < epsf Or iter = itermax

    End Sub

    Private Function EquaValue(ByVal cbuf() As Single, _
        ByVal xb As Single) As Single
        'Xに対する関数値
        'cbuf()･･･係数
        'xb･･･Xの値
        EquaValue = xb ^ 3 + cbuf(2) * xb * xb + cbuf(1) * xb + cbuf(0)

    End Function

    Private Sub FALoadSet()
        '座標位置荷重の設定
        Dim aa$
        Dim i, id, j, k, kb, ke, kk, nmax As Integer
        Dim s, t, u, xb, yb, zb As Single

        If KindElem = 0 Then
            nmax = 20
        End If
        Call AxisCheck(1, Nelem, Rlenmax, AxisMax, AxisMin, Xdata, Ydata, Zdata)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        EpsL = Rlenmax * 0.00001

        CInc = 3
        CRed = 0.2
        For i = 1 To NforceA
            xb = XFA(i)
            yb = YFA(i)
            zb = ZFA(i)
            Call ElemFA(ke, s, t, u, xb, yb, zb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                Me.Close()
            End If
            For j = 1 To nmax
                kk = NNelem(ke, j)
                kb = Ndim * (Kcomp(kk) - 1)
                For id = 1 To Ndim
                    k = kb + id
                    If Lcomp(k) > 0 Then
                        TfD(Lcomp(k)) = TfD(Lcomp(k)) + Shape(j) * ForceA(i, id)
                    End If
                Next id
            Next j
        Next i

    End Sub

    Private Sub FLoadSet()
        '節点荷重の設定
        Dim i, id, j, kk As Integer
        For i = 1 To Nforce
            kk = KPforce(i)
            j = Ndim * (Kcomp(kk) - 1)
            For id = 1 To Ndim
                j = j + 1
                If Lcomp(j) > 0 Then
                    TfD(Lcomp(j)) = Force(i, id)
                End If
            Next id
        Next i

    End Sub

    Private Sub GLoadSet()
        '自重の節点荷重への換算
        Dim i, ie, ig, ii, j, j1, j2, jb, jg As Integer
        Dim k, kb, kg, kgaus, kp, nmax, numg As Integer
        Dim b1, b2, dj, dv, gforce, omega2 As Double
        Dim r1, r2, ratio, rmass As Double
        Dim s, sumdiag, t, totalmass, u As Double
        Dim buf(20) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        If KindRevF > 0 Then    '回転遠心力有りの場合
            kgaus = 1
            b1 = Dpai * RevPS
            omega2 = b1 * b1
        End If

        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                gforce = DataMat(kp, 3)
                kp = kb
            End If

            For ii = 1 To nmax
                buf(ii) = 0
                i = NNelem(ie, ii)
                XE(ii) = Xdata(i)
                YE(ii) = Ydata(i)
                ZE(ii) = Zdata(i)
            Next ii

            totalmass = 0   '要素重量合計
            sumdiag = 0     '節点の積分重量合計
            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            numg = numg + 1
                            u = PosGaus(kg)
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElem(ie, kgaus, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            b1 = gforce * dv
                            If KindGrav > 0 Then
                                totalmass = totalmass + b1
                                For i = 1 To 20
                                    b2 = b1 * Shape(i) * Shape(i)
                                    sumdiag = sumdiag + b2
                                    buf(i) = buf(i) + b2
                                Next i
                            End If
                            If KindRevF > 0 Then
                                rmass = b1 / AccGrav
                                Select Case KindRevF
                                    Case 1  'X軸回り
                                        j1 = 2
                                        j2 = 3
                                        r1 = YG(numg)
                                        r2 = ZG(numg)
                                    Case 2  'Y軸回り
                                        j1 = 3
                                        j2 = 1
                                        r1 = ZG(numg)
                                        r2 = XG(numg)
                                    Case 3  'Z軸回り
                                        j1 = 1
                                        j2 = 2
                                        r1 = XG(numg)
                                        r2 = YG(numg)
                                End Select
                                For ii = 1 To 20
                                    b2 = rmass * Shape(ii)
                                    i = NNelem(ie, ii)
                                    j = Ndim * (i - 1)
                                    jb = j + j1
                                    If Lcomp(jb) > 0 Then
                                        TfD(Lcomp(jb)) = TfD(Lcomp(jb)) + b2 * omega2 * r1
                                    End If
                                    jb = j + j2
                                    If Lcomp(jb) > 0 Then
                                        TfD(Lcomp(jb)) = TfD(Lcomp(jb)) + b2 * omega2 * r2
                                    End If
                                Next ii
                            End If
                        Next kg
                    Next jg
                Next ig
            End If

            If KindGrav > 0 And sumdiag <> 0 Then
                '要素重量合計の補正・蓄積
                ratio = totalmass / sumdiag
                For ii = 1 To nmax
                    b1 = buf(ii) * ratio
                    i = NNelem(ie, ii)
                    j = Ndim * (Kcomp(i) - 1)
                    For k = 1 To 3
                        j = j + 1
                        b2 = b1 * GravMulti(k)
                        If Lcomp(j) > 0 Then
                            TfD(Lcomp(j)) = TfD(Lcomp(j)) + b2
                        End If
                    Next k
                Next ii
            End If

        Next ie

    End Sub

    Private Sub HLoadSet()
        '分布荷重の節点荷重への換算
        Dim i, ib, id, ie, ii, j, jb, jj, jmax As Integer
        Dim k1, k2, kb, kgp1, kgp2, kind, kmax, kk, nb, nmax, numg As Integer
        Dim b1, da, dj, xb, yb, zb As Double
        Dim kbuf(8) As Integer
        Dim planevec(3), xbuf(3), ybuf(3), zbuf(3) As Single
        Dim gpos(3) As Single

        If KindElem = 0 Then
            jmax = 8
            kmax = 6
            nmax = 20
            nb = 4
        End If
        For ii = 1 To Nsurf
            ie = KPsurf(ii, 1)
            kb = KPsurf(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j

            xb = 0 : yb = 0 : zb = 0
            For j = 2 To jmax Step 2
                kb = kbuf(j)
                ib = NNelem(ie, kb)
                xb = xb + Xdata(ib)
                yb = yb + Ydata(ib)
                zb = zb + Zdata(ib)
                Select Case j
                    Case 2
                        xbuf(2) = Xdata(ib)
                        ybuf(2) = Ydata(ib)
                        zbuf(2) = Zdata(ib)
                    Case 4
                        xbuf(3) = Xdata(ib)
                        ybuf(3) = Ydata(ib)
                        zbuf(3) = Zdata(ib)
                End Select
            Next j
            xbuf(1) = xb / nb
            ybuf(1) = yb / nb
            zbuf(1) = zb / nb

            Call SurfaceVector(planevec, xbuf, ybuf, zbuf)
            '面の法線ﾍﾞｸﾄﾙの計算

            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select
                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            b1 = Pnorm(ii) * Shape(kk) * da
                            jb = Ndim * (j - 1)
                            For id = 1 To 3
                                jb = jb + 1
                                If Lcomp(jb) > 0 Then
                                    TfD(Lcomp(jb)) = TfD(Lcomp(jb)) - b1 * planevec(id)
                                End If
                            Next id
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub InitAdjust(ByVal nx As Integer)
        '初期値調整
        'nx･･･次数
        Dim i As Integer
        Dim alp, b1 As Single

        alp = 0.6
        b1 = 1 - alp
        For i = 1 To nx
            If KAccSet(i) = 0 Then
                Accel2(i) = alp * Accel0(i) + b1 * Accel2(i)
                Disp2(i) = alp * Disp0(i) + b1 * Disp2(i)
                Vel2(i) = alp * Vel0(i) + b1 * Vel2(i)
            End If
            Accel0(i) = Accel2(i)
            Disp0(i) = Disp2(i)
            Vel0(i) = Vel2(i)
        Next i

    End Sub

    Private Sub InitBase()
        '初期ﾍﾞｰｽ設定
        Dim i, ic, id, ie, j, jb, jmax, k, kb, nb, nex As Integer

        If KindElem = 0 Then
            Nvar = 60
            jmax = 8
        End If
        Nstress = 6
        Nall = Ndim * Npoint

        ReDim NPrefer(Nvar), Ek(Nvar, Nvar), B(Nstress, Nvar)
        ReDim D(Nstress, Nstress), Db(Nstress, Nvar)
        ReDim Nw(Npoint), Eu(Nvar)
        ReDim Sgaus(27, Nstress), Spoint(20, Nstress)
        ReDim Tp(Npoint, Nstress), TfS(Nall)

        '拘束ﾃﾞｰﾀの処理
        nb = NboundP
        If NboundS > 0 Then
            nb = nb + jmax * NboundS
        End If
        If nb > 0 Then
            Dim nrp(nb), jfix(nb, Ndim) As Integer
            Dim vfix(nb, Ndim) As Single
            k = 0
            If NboundP > 0 Then
                For i = 1 To NboundP
                    k = k + 1
                    nrp(k) = NrestP(i)
                    For id = 1 To Ndim
                        jfix(k, id) = JdirectP(i, id)
                        vfix(k, id) = VdirectP(i, id)
                    Next id
                Next i
            End If
            If NboundS > 0 Then
                Dim kbuf(8) As Integer
                For i = 1 To NboundS
                    ie = KBsurf(i, 1)
                    kb = KBsurf(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = k + 1
                        nrp(k) = kbuf(j)
                        For id = 1 To Ndim
                            jfix(k, id) = JdirectS(i, id)
                            vfix(k, id) = VdirectS(i, id)
                        Next id
                    Next j
                Next i
            End If
            '節点重複の削除･･･最大採用
            For i = 1 To nb
                For j = i + 1 To nb
                    If nrp(i) = nrp(j) Then
                        For id = 1 To Ndim
                            If jfix(j, id) > 0 Then
                                ic = 0
                                If jfix(i, id) = 0 Then
                                    ic = 1
                                ElseIf vfix(j, id) > vfix(i, id) Then
                                    ic = 1
                                End If
                                If ic > 0 Then
                                    jfix(i, id) = 1
                                    vfix(i, id) = vfix(j, id)
                                End If
                            End If
                        Next id
                        nrp(j) = 0
                    End If
                Next j
            Next i
            '拘束条件を新規保存（節点番号順）
            Nbound = 0
            For i = 1 To nb
                If nrp(i) > 0 Then
                    Nbound = Nbound + 1
                End If
            Next i
            ReDim Nrest(Nbound), Jdirect(Nbound, Ndim), Vdirect(Nbound, Ndim)
            For i = 1 To Nbound
                ic = 0
                For j = 1 To nb
                    If nrp(j) > 0 Then
                        If ic = 0 Then
                            k = j
                            ic = 1
                        ElseIf nrp(j) < nrp(k) Then
                            k = j
                        End If
                    End If
                Next j
                Nrest(i) = nrp(k)
                For id = 1 To Ndim
                    Jdirect(i, id) = jfix(k, id)
                    Vdirect(i, id) = vfix(k, id)
                Next id
                nrp(k) = 0
            Next i
        End If

        '変数固定の整理
        Dim nrc(Nbound) As Integer
        NBvar = 0
        For i = 1 To Nbound
            nrc(i) = 1
            For j = 1 To Ndim
                If Jdirect(i, j) <> 0 Then
                    NBvar = NBvar + 1
                End If
            Next j
        Next i
        ReDim KBfix(NBvar), VBfix(NBvar)
        jb = 0
        For i = 1 To Nbound
            ic = 0
            For j = 1 To Nbound
                If nrc(j) > 0 Then
                    If ic = 0 Then
                        k = j
                        kb = Kcomp(Nrest(j))
                        ic = 1
                    ElseIf Kcomp(Nrest(j)) < kb Then
                        k = j
                        kb = Kcomp(Nrest(j))
                    End If
                End If
            Next j
            kb = Ndim * (kb - 1)    '改良節点順
            For j = 1 To Ndim
                If Jdirect(k, j) <> 0 Then
                    jb = jb + 1
                    KBfix(jb) = kb + j
                    VBfix(jb) = Vdirect(k, j)
                End If
            Next j
            nrc(k) = 0
        Next i

        '縮小ﾏﾄﾘｯｸｽの設定
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i

        nex = 0
        If Kboundfree = 0 Then
            For i = 1 To NBvar  '0固定の変位変数の除去
                If VBfix(i) = 0 Then
                    nex = nex + 1
                    Lcomp(KBfix(i)) = 0
                End If
            Next i
        End If
        Neff = Nall - nex
        ReDim TfD(Neff)

        j = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                j = j + 1
                Lcomp(i) = j
            End If
        Next i

        If KindElem = 0 Then
            Call TrSet(Tr)    'Tr行列の設定
        End If

        If KAnal = 0 Then
            Call RoundPrep2(KindTime, NbTime, DTime) '丸め準備2
        End If

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ib, j, k, nb As Integer

        If Kboundfree = 0 Then
            '強制変位の削除
            nb = 0
            For i = 1 To NBvar
                If VBfix(i) <> 0 Then
                    ib = KBfix(i)
                    Call MatReduct(ib, Neff, NumEff)   '行列から１変数分削除
                    nb = nb + 1
                End If
            Next i
            If nb > 0 Then
                nb = 0
                For i = 1 To Npoint     '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
                    k = Ndim * (i - 1)
                    For j = 1 To Ndim
                        k = k + 1
                        If Lcomp(k) > 0 Then
                            nb = nb + 1
                            Lcomp(k) = nb
                            'NodeMatR(nb) = i
                            'KdispMatR(nb) = j
                        End If
                    Next j
                Next i
            End If
        End If

    End Sub

    Private Sub InitialSet2()
        '初期設定2
        Dim i, ii, j, jj, k, kb, nmax As Integer
        ReDim KAccSet(Norder), KDispSet(Norder)
        If KindElem = 0 Then
            nmax = 20
        End If
        If KindLvib = 1 Then
            For i = 1 To NPvib
                ii = Ndim * (Kcomp(KPvib(i)) - 1)
                For j = 1 To Ndim
                    If JLoadVib(i, j) > 0 Then
                        kb = Lcomp(ii + j)
                        If kb > 0 Then
                            KAccSet(kb) = 1
                            If KAnal = 1 Then
                                KDispSet(kb) = 1
                            End If
                        End If
                    End If
                Next j
            Next i
        End If

        If KAnal = 1 Then
            ReDim KcheckP(Norder)
            If KindLvib = 1 Then
                Dim ic, ie As Integer
                For i = 1 To NPvib
                    For j = 1 To Ndim
                        If JLoadVib(i, j) > 0 Then
                            For ie = 1 To Nelem
                                ic = 0
                                For jj = 1 To nmax
                                    If NNelem(ie, jj) = KPvib(i) Then
                                        ic = 1
                                        Exit For
                                    End If
                                Next jj
                                If ic > 0 Then
                                    For jj = 1 To nmax
                                        ii = Ndim * (Kcomp(NNelem(ie, jj)) - 1)
                                        For k = 1 To Ndim
                                            kb = Lcomp(ii + k)
                                            If kb > 0 Then
                                                KcheckP(kb) = 1
                                            End If
                                        Next k
                                    Next jj
                                End If
                            Next ie
                        End If
                    Next j
                Next i
            End If
        End If

    End Sub

    Private Sub InitialSet2S(ByVal mb As Integer)
        '初期設定2S（静荷重用）
        Dim aa$
        Dim i, i1, ib, ic, id, ie, ii, ip, j, k, k1, k2, kk, nmax, num, numall As Integer
        Dim b1, freemem, reqmem As Single
        Dim nbuf(Npoint) As Integer
        ReDim Idiag(Neff)

        If KindElem = 0 Then
            nmax = 20
        End If
        '関連節点数の計算
        numall = 0
        For i = 1 To Npoint
            ic = 0
            k = Ndim * (i - 1)
            For id = 1 To Ndim
                If Lcomp(k + id) > 0 Then
                    ic = 1
                    Exit For
                End If
            Next id
            If ic > 0 Then
                For j = 1 To i
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To Nelem
                    ic = 0
                    For ii = 1 To nmax
                        If NNelem(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelem(ie, ii))
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        Next ii
                    End If
                Next ie
                If Nspring > 0 Then
                    For j = 1 To Nspring
                        k1 = KPspring(j, 1)
                        k2 = KPspring(j, 2)
                        If k1 = ip Then
                            If k2 > 0 Then
                                ib = Kcomp(k2)
                                If ib <= i Then
                                    nbuf(ib) = 1
                                End If
                            End If
                        ElseIf k2 = ip Then
                            ib = Kcomp(k1)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    Next j
                End If
                i1 = 0
                For j = 1 To i
                    If nbuf(j) > 0 Then
                        i1 = j
                        Exit For
                    End If
                Next j
                k1 = 0
                For j = i1 To i
                    k = Ndim * (j - 1)
                    For id = 1 To Ndim
                        If Lcomp(k + id) > 0 Then
                            k1 = Lcomp(k + id)
                            Exit For
                        End If
                    Next id
                    If k1 > 0 Then
                        Exit For
                    End If
                Next j
                k = Ndim * (i - 1)
                For id = 1 To Ndim
                    kk = Lcomp(k + id)
                    If kk > 0 Then
                        num = kk - k1 + 1
                        numall = numall + num
                        Idiag(kk) = numall
                    End If
                Next id
            End If
        Next i
        NumEff = numall

        freemem = 1000 * FreeMemoryGet()
        reqmem = 16.0 * NumEff * 1.05
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "バンド幅が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "スカイライン法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(NumEff), RKmatb(NumEff)

    End Sub

    Private Sub InitialLoad()
        '初期荷重

        If Nforce > 0 Then
            Call FLoadSet() '節点荷重の設定
        End If

        If NforceA > 0 Then
            Call FALoadSet() '座標位置荷重の設定
        End If

        If Nsurf > 0 Then
            Call HLoadSet() '分布荷重の節点荷重への換算
        End If

        If KindGrav > 0 Or KindRevF > 0 Then
            Call GLoadSet() '自重の節点荷重への換算
        End If

    End Sub

    Private Sub LoadVibNew(ByRef kh As Integer, ByRef itime As Integer)
        '振動外力区間の新規設定
        'kh･･･振動外力終了の有無（0:なし、1:有り）
        'itime･･･振動外力のﾒｯｼｭ番号
        Dim i, j, nb As Integer
        kh = 0
        If itime <= NvibTime Then
            nb = 0
            For i = 1 To NPvib
                For j = 1 To Ndim
                    If JLoadVib(i, j) > 0 Then
                        nb = nb + 1
                        FLoadVib(i, j) = FLvibTime(itime, nb)
                    End If
                Next j
            Next i
            itime = itime + 1
        Else
            kh = 1
        End If

    End Sub

    Private Sub LoadVibSet(ByRef kh As Integer, ByVal kind As Integer, _
        ByVal istep As Integer, ByVal nstepb As Integer)
        '振動外力の設定
        'kh･･･振動外力終了の有無（0:なし、1:有り、-1以下:不要）
        'kind･･･外力区分（0:力、1:加速度）
        'istep･･･計算時間ﾒｯｼｭ番号
        'nstepb･･･振動外力時間間隔の倍数
        Dim i, ii, j, k As Integer
        Dim b1, b2, b3 As Single
        Select Case kh
            Case Is >= 0
                If kh = 0 Then
                    b1 = istep Mod nstepb
                    b2 = b1 / nstepb
                    b1 = 1 - b2
                End If
                For i = 1 To NPvib
                    ii = Ndim * (Kcomp(KPvib(i)) - 1)
                    For j = 1 To Ndim
                        If JLoadVib(i, j) > 0 Then
                            If kh = 0 Then
                                b3 = b1 * FLoadVibI(i, j) + b2 * FLoadVib(i, j)
                            Else
                                b3 = FLoadVib(i, j)
                            End If
                            FLoadVibX(i, j) = b3
                            k = Lcomp(ii + j)
                            If k > 0 Then
                                If kind = 0 Then
                                    TfD(k) = b3
                                Else
                                    Accel2(k) = b3
                                End If
                            End If
                        End If
                    Next j
                Next i
                If kh = 1 Then
                    kh = -1
                End If
            Case Else
                If kind = 1 Then
                    For i = 1 To Norder
                        KAccSet(i) = 0
                    Next i
                End If
                kh = -2
                KVibOff = 1
        End Select

    End Sub

    Private Sub LoadVibSet2(ByVal kind As Integer, ByVal istep As Integer)
        '振動外力の設定
        'kind･･･外力区分（0:力、1:加速度）
        'istep･･･ｻｲｸﾙ分割番号
        Dim i, ii, j, k, n As Integer
        Dim b3, c1, c2, c3, c4, omega As Single

        omega = Dpai * FreqLVib
        If istep < NdivCyc Then
            c1 = Dpai * istep / NdivCyc
        Else
            c1 = 0
        End If
        c4 = Pai / 180
        n = 0
        For i = 1 To NPvib
            ii = Ndim * (Kcomp(KPvib(i)) - 1)
            For j = 1 To Ndim
                If JLoadVib(i, j) > 0 Then
                    n = n + 1
                    c2 = Math.Sin(c1 + c4 * DataFreq(n, 2))
                    c3 = Math.Cos(c1 + c4 * DataFreq(n, 2))
                    b3 = DataFreq(n, 1) * c2
                    FLoadVibX(i, j) = b3
                    k = Lcomp(ii + j)
                    If k > 0 Then
                        If kind = 0 Then
                            TfD(k) = b3
                        Else
                            Accel2(k) = b3
                            Vel2(k) = -DataFreq(n, 1) * c3 / omega
                            Disp2(k) = -b3 / (omega * omega)
                        End If
                    End If
                End If
            Next j
        Next i

    End Sub

    Private Sub MatMaxCalc()
        '行列要素の最大値計算
        Dim i, ii As Integer
        For i = 1 To Norder
            ii = Idiag(i)
            If RMmatrix(i) > RMmax Then
                RMmax = RMmatrix(i)
            End If
            If RKmatb(ii) > RKmax Then
                RKmax = RKmatb(ii)
            End If
        Next i
        If KindVEqua > 0 Then
            For i = 1 To Norder
                If Cmatb(ii) > Cmax Then
                    Cmax = Cmatb(ii)
                End If
            Next i
        End If

    End Sub

    Private Sub MatReduct(ByVal i As Integer, ByRef nx As Integer, _
    ByRef num As Integer)
        '行列から１変数分削除
        'i･･･全体変数番号
        'nx･･･変数の数（1減らして戻す）
        'num･･･行列のｲﾝﾃﾞｯｸｽ数（修正して戻す）
        Dim ib, j, k, k2, kb, kk, kx, ndel As Integer

        kb = Lcomp(i)
        For k = 1 To nx
            If Lcomp(k) > kb Then
                Lcomp(k) = Lcomp(k) - 1
            End If
        Next k
        Lcomp(i) = 0
        k2 = kb + Mband - 1
        If k2 > nx Then
            k2 = nx
        End If
        For k = k2 To kb + 1 Step -1
            ib = k - kb
            kx = Idiag(k) - ib
            If kx > Idiag(k - 1) Then
                For j = kx + 1 To num
                    RKmatb(j - 1) = RKmatb(j)
                Next j
                RKmatb(num) = 0
                num = num - 1
                For kk = k To nx
                    Idiag(kk) = Idiag(kk) - 1
                Next kk
            End If
        Next k
        ndel = Idiag(kb) - Idiag(kb - 1)
        If kb < nx Then
            For j = Idiag(kb) + 1 To num
                RKmatb(j - ndel) = RKmatb(j)
            Next j
            For k = kb + 1 To nx
                Idiag(k - 1) = Idiag(k) - ndel
            Next k
        End If
        For j = 1 To ndel
            RKmatb(num - j + 1) = 0
        Next j
        nx = nx - 1
        num = num - ndel

    End Sub

    Private Sub MmatSet()
        'Ｍ行列の設定
        Dim i, ii, j, k As Integer
        ReDim RMmatb(Norder)

        ii = 0
        For i = 1 To Npoint
            k = Ndim * (Kcomp(i) - 1)
            For j = 1 To Ndim
                k = k + 1
                If Lcomp(k) > 0 Then
                    ii = ii + 1
                    RMmatb(Lcomp(k)) = RMmatrix(ii)
                End If
            Next j
        Next i

    End Sub

    Private Sub NewStep(ByVal nx As Integer)  '新ｽﾃｯﾌﾟ準備
        'nx･･･次数
        Dim i As Integer
        For i = 1 To nx
            Accel1(i) = Accel2(i)
            Disp1(i) = Disp2(i)
            Vel1(i) = Vel2(i)
            Accel2(i) = 0
            Disp2(i) = 0
            Vel2(i) = 0
        Next i

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox2.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力
        'UTF-8･･･BOMなし
        Dim a1$, aa$, ad$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用

        If KindVEqua = 0 Then
            a1$ = "ＭＫ型"
        Else
            a1$ = "ＭＣＫ型"
        End If
        aa$ = "＜＜" + a1$ + "3D振動応答解析の結果＞＞"
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)
        aa$ = "［入力ﾃﾞｰﾀﾌｧｲﾙ］" + "," + Fm$
        SwK.WriteLine(aa$)
        If KAnal = 0 Then
            aa$ = "一般応答"
        Else
            aa$ = "周波数応答"
        End If
        aa$ = "解析種類：" + aa$
        SwK.WriteLine(aa$)
        If KindSLoad = 0 Then
            SwK.WriteLine("静荷重なし")
        Else
            SwK.WriteLine("静荷重有り")
        End If

        aa$ = "＜パラメーター条件＞"
        SwK.WriteLine(aa$)
        If KAnal = 0 Then
            aa$ = "計算打切り時間" + "," + Str(TimeMax)
            SwK.WriteLine(aa$)
            aa$ = "計算時間間隔" + "," + Str(DTime)
            SwK.WriteLine(aa$)
            aa$ = "振動外力時間間隔の倍率" + "," + Str(NstepF)
            SwK.WriteLine(aa$)
            aa$ = "出力時間間隔の倍率" + "," + Str(Nstep)
            SwK.WriteLine(aa$)
        Else
            aa$ = "最大繰返し数" + "," + Str(NKmax)
            SwK.WriteLine(aa$)
            aa$ = "１周期分割数" + "," + Str(NdivCyc)
            SwK.WriteLine(aa$)
            aa$ = "収束判定誤差比率" + "," + Str(EpsCalc)
            SwK.WriteLine(aa$)
        End If
        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＊＊＊ 計算結果（スカイライン法） ＊＊＊")
        aa$ = "計算マトリックスの変数個数、ハーフバンド幅、保存インデックス数（"
        If KindVEqua = 0 Then
            aa$ = aa$ + "２個）"
        Else
            aa$ = aa$ + "３個）"
        End If
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Neff) + ",   " + Str(mb) + ",   " + Str(NumEff)
        SwK.WriteLine(aa$)
        aa$ = "Ｍ行列要素の最大値" + "," + Str(RMmax)
        SwK.WriteLine(aa$)
        If KindVEqua > 0 Then
            aa$ = "Ｃ行列要素の最大値" + "," + Str(Cmax)
            SwK.WriteLine(aa$)
        End If
        aa$ = "Ｋ行列要素の最大値" + "," + Str(RKmax)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile2(ByVal kh As Integer, ByVal istep As Integer)
        '結果ﾌｧｲﾙへの出力2
        'kh･･･振動外力ﾃﾞｰﾀの有無（-1以上:有り、-2:なし）
        'istep･･･時間ﾒｯｼｭ番号
        Dim a1$, aa$, ad$
        Dim i, ic, id, ii, j, jb, k As Integer
        Dim b1, c1 As Single
        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        If KAnal = 0 Then
            aa$ = "＜時間メッシュ番号、時間＞"
            aa$ = aa$ + "," + Str(istep) + "," + Str(TimeNew)
            SwK.WriteLine(aa$)
            a1$ = "時間、"
            c1 = TimeNew
        Else
            aa$ = "＜周期内メッシュ番号、角度、周期内時間＞"
            c1 = 360.0 * istep / NdivCyc
            b1 = DTime * istep
            aa$ = aa$ + "," + Str(istep) + "," + Str(c1) + "," + Str(b1)
            SwK.WriteLine(aa$)
            a1$ = "角度、"
        End If
        SwK.WriteLine("＜振動外力データ＞")
        If kh > -2 Then
            If KindLvib = 0 Then
                aa$ = a1$ + "節点番号、X方向外力、Y方向外力、Z方向外力"
            Else
                aa$ = a1$ + "節点番号、X方向加速度、Y方向加速度、Z方向加速度"
            End If
            SwK.WriteLine(aa$)
            For i = 1 To NPvib
                aa$ = Str$(c1) + ",  " + Str$(KPvib(i))
                For j = 1 To 3
                    b1 = FLoadVibX(i, j)
                    aa$ = aa$ + ",  " + Str$(b1)
                    If Math.Abs(b1) > Math.Abs(FLvibMax(j)) Then
                        FLvibMax(j) = b1
                        KFLvibMax(j) = KPvib(i)
                        TFLvibMax(j) = c1
                    End If
                Next j
                SwK.WriteLine(aa$)
            Next i
        Else
            SwK.WriteLine("  なし")
        End If

        aa$ = a1$ + "節点番号、δX、δY、δZ"
        SwK.WriteLine("＜変位データ＞")
        SwK.WriteLine(aa$)
        For i = 1 To Npoint
            aa$ = Str$(c1) + ",  " + Str$(i)
            ii = Ndim * (i - 1)
            j = Ndim * (Kcomp(i) - 1)
            For id = 1 To 3
                k = ii + id
                jb = j + id
                b1 = TfS(k) + Disp2(Lcomp(jb))
                aa$ = aa$ + ",  " + Str$(b1)
                If Math.Abs(b1) > Math.Abs(DispMax(id)) Then
                    DispMax(id) = b1
                    KDispMax(id) = i
                    TDispMax(id) = c1
                End If
            Next id
            SwK.WriteLine(aa$)
        Next i

        Dim sx, sy, sz, txy, tyz, tzx, sm1, sm2, sm, tmax As Single
        ic = 0
        If TimeNew = 0 Then
            ic = 1
        End If
        aa$ = a1$ + "節点番号、σx、σy、σz、τxy、τyz、τzx、"
        aa$ = aa$ + "σmax、σmin、τmax、σmises"
        SwK.WriteLine("＜応力データ＞")
        SwK.WriteLine(aa$)
        For i = 1 To Npoint
            aa$ = Str$(c1) + ",  " + Str$(i)
            If Nw(i) > 0 Then
                sx = Tp(i, 1) / Nw(i)
                sy = Tp(i, 2) / Nw(i)
                sz = Tp(i, 3) / Nw(i)
                txy = Tp(i, 4) / Nw(i)
                tyz = Tp(i, 5) / Nw(i)
                tzx = Tp(i, 6) / Nw(i)
                '主応力の計算
                Call StressMain(sx, sy, sz, txy, tyz, tzx, sm1, sm2, tmax, sm)
            Else
                aa$ = "節点" + Str$(i) + " の応力を計算できません！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            aa$ = aa$ + ",  " + Str$(sx) + ",  " + Str$(sy)
            aa$ = aa$ + ",  " + Str$(sz) + ",  " + Str$(txy)
            aa$ = aa$ + ",  " + Str$(tyz) + ",  " + Str$(tzx)
            aa$ = aa$ + ",  " + Str$(sm1) + ",  " + Str$(sm2)
            aa$ = aa$ + ",  " + Str$(tmax) + ",  " + Str$(sm)
            SwK.WriteLine(aa$)
            For k = 1 To 10
                Select Case k
                    Case 1
                        b1 = sx
                    Case 2
                        b1 = sy
                    Case 3
                        b1 = sz
                    Case 4
                        b1 = txy
                    Case 5
                        b1 = tyz
                    Case 6
                        b1 = tzx
                    Case 7
                        If ic > 0 Or sm1 > StMax(7) Then
                            StMax(7) = sm1
                            KStMax(7) = i
                            TStMax(7) = c1
                        End If
                    Case 8
                        If ic > 0 Or sm2 < StMax(8) Then
                            StMax(8) = sm2
                            KStMax(8) = i
                            TStMax(8) = c1
                            ic = 0
                        End If
                    Case 9
                        b1 = tmax
                    Case 10
                        b1 = sm
                End Select
                If k <> 7 And k <> 8 Then
                    If Math.Abs(b1) > Math.Abs(StMax(k)) Then
                        StMax(k) = b1
                        KStMax(k) = i
                        TStMax(k) = c1
                    End If
                End If
            Next k
        Next i

    End Sub

    Private Sub ResFile3(ByVal iconv As Integer)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:なし、1:有り）
        Dim aa$, ad$
        Dim i As Integer

        ad$ = "-------------------------------------------------------"
        aa$ = "注）σmax、σminは正負込みの最大、最小。その他は絶対値の最大。"
        SwK.WriteLine(ad$)
        If KAnal = 1 And iconv < 2 Then
            If iconv = 0 Then
                SwK.WriteLine("収束なし")
            Else
                SwK.WriteLine("最終回に収束有り")
            End If
            Exit Sub
        End If
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、  最大値、          節点番号、"
        If KAnal = 0 Then
            aa$ = aa$ + "   時間"
        Else
            aa$ = aa$ + "   周期内角度"
        End If
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To 3
            If FLvibMax(i) <> 0 Then
                Select Case i
                    Case 1
                        aa$ = "Ｆvx"
                    Case 2
                        aa$ = "Ｆvy"
                    Case 3
                        aa$ = "Ｆvz"
                End Select
                aa$ = aa$ + ",  "
                aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(FLvibMax(i)) + ",  "
                aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KFLvibMax(i)) + ",  "
                aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TFLvibMax(i))
                SwK.WriteLine(aa$)
            End If
        Next i
        For i = 1 To 3
            Select Case i
                Case 1
                    aa$ = "δX"
                Case 2
                    aa$ = "δY"
                Case 3
                    aa$ = "δZ"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(DispMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KDispMax(i)) + ",  "
            aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TDispMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i
        For i = 1 To 10
            Select Case i
                Case 1
                    aa$ = "σx"
                Case 2
                    aa$ = "σy"
                Case 3
                    aa$ = "σz"
                Case 4
                    aa$ = "τxy"
                Case 5
                    aa$ = "τyz"
                Case 6
                    aa$ = "τzx"
                Case 7
                    aa$ = "σmax"
                Case 8
                    aa$ = "σmin"
                Case 9
                    aa$ = "τmax"
                Case 10
                    aa$ = "σmises"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(StMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KStMax(i)) + ",  "
            aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TStMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal nx As Integer, ByVal ub As Single)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        'ub･･･拘束値
        Dim it, j, k1, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it
                k1 = Idiag(k) - j
                If k1 > Idiag(k - 1) Then
                    If ub <> 0 Then
                        TfD(it) = TfD(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next it
        End If
        If k < nx Then
            mx = mb
            If k + mb - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        TfD(it) = TfD(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        TfD(k) = ub

    End Sub

    Private Sub Solver1(ByVal nx As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, i0, icount, ii, ij, ik, jk, j, j0, jj, jm1, k, kk, mi, mij, mj As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        For i = 2 To nx
            i0 = Idiag(i) - i
            mi = Idiag(i - 1) - i0 + 1
            For j = mi To i
                sum = 0
                j0 = Idiag(j) - j
                mj = 1
                If j > 1 Then
                    mj = Idiag(j - 1) - j0 + 1
                End If
                mij = mi
                If mj > mi Then
                    mij = mj
                End If
                ij = i0 + j
                jm1 = j - 1
                For k = mij To jm1
                    If mij <= jm1 Then
                        ik = i0 + k
                        kk = Idiag(k)
                        jk = j0 + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    End If
                Next k
                If j = i Then
                    ii = i0 + i
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer, ByVal nx As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, i0, i1, j, j0, j1, j2, j3, k As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        For i = 2 To nx
            sum = 0
            i0 = Idiag(i) - i
            j1 = Idiag(i - 1) - i0 + 1
            j2 = i - 1
            If j1 <> i Then
                For j = j1 To j2
                    j0 = i0 + j
                    sum = sum + Tk(j0) * TfD(j)
                Next j
            End If
            TfD(i) = TfD(i) - sum
        Next i
        For i = 1 To nx
            i1 = Idiag(i)
            If Tk(i1) <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0以下になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            TfD(i) = TfD(i) / Tk(i1)
        Next i

        For k = nx - 1 To 1 Step -1
            j1 = k + 1
            j2 = j1 + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= k Then
                    j0 = Idiag(j) - j + k
                    sum = sum + Tk(j0) * TfD(j)
                End If
            Next j
            TfD(k) = TfD(k) - sum
        Next k

        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kk, kx, kz, m As Integer
        Dim b1 As Single
        Dim acos(3), aval1(3), aval2(3), csb(3), fsb(3) As Single
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                For j = 1 To 3
                    k = k + 1
                    If Lcomp(k) > 0 Then
                        kk = Idiag(Lcomp(k))
                        Tk(kk) = Tk(kk) - Cspring(ib, j)
                        TfD(Lcomp(k)) = TfD(Lcomp(k)) + Fspring(ib, j)
                    End If
                Next j
            Else  '節点間ﾊﾞﾈ
                k1 = KPspring(ib, 1)
                k2 = KPspring(ib, 2)
                aval1(1) = Xdata(k1)
                aval1(2) = Ydata(k1)
                aval1(3) = Zdata(k1)
                aval2(1) = Xdata(k2)
                aval2(2) = Ydata(k2)
                aval2(3) = Zdata(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 3
                    csb(j) = Cspring(ib, 1) * acos(j)
                    fsb(j) = Fspring(ib, 1) * acos(j)
                Next j
                k1 = Ndim * (Kcomp(k1) - 1)
                k2 = Ndim * (Kcomp(k2) - 1)
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 3  'XYZ方向
                        k = k + 1
                        kx = Lcomp(k)
                        If kx > 0 Then
                            kk = Idiag(kx)
                            Tk(kk) = Tk(kk) - csb(j) * acos(j)
                            TfD(kx) = TfD(kx) + b1 * fsb(j)
                            If j < 3 Then
                                For jj = j + 1 To 3
                                    kb = k + jj - 1
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) - csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If
                            If m = 1 And k1 < k2 Then   '大きい変数番号の側で記憶
                                For jj = 1 To 3
                                    kb = k2 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            ElseIf m = 2 And k2 < k1 Then
                                For jj = 1 To 3
                                    kb = k1 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If

                        End If
                    Next j
                Next m
            End If
        Next ib
    End Sub

    Private Sub StoreS()
        '全体ﾏﾄﾘｯｸｽへの蓄積（静荷重用）
        Dim i, it, j, jt, k As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it > jt Then
                            k = Idiag(it) - it + jt
                        Else
                            k = Idiag(jt) - jt + it
                        End If
                        Tk(k) = Tk(k) + Ek(i, j)
                    End If
                Next j
            End If
        Next i
    End Sub

    Private Sub StressCalc()
        '応力計算
        Dim i, icount, id, ie, ii, isb, istage, j, jmax, k, kb, nmax As Integer
        Dim b1, e, rnu As Single

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
            Call TrSet(Tr)  '節点応力計算のTr行列の設定
        End If
        istage = 1
        kb = 0
        For i = 1 To Npoint
            Nw(i) = 0
            For j = 1 To Nstress
                Tp(i, j) = 0
            Next j
        Next i
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            j = 0
            For ii = 1 To nmax
                i = NNelem(ie, ii)
                k = Ndim * (i - 1)
                kb = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    kb = kb + 1
                    Eu(j) = TfS(k) + Disp2(Lcomp(kb))
                Next id
            Next ii
            Call ElemMatrix(ie, istage, kb, e, rnu)      '要素ﾏﾄﾘｯｸｽの計算2
            For i = 1 To nmax
                For isb = 1 To Nstress
                    Spoint(i, isb) = 0
                Next isb
                For j = 1 To jmax
                    b1 = Tr(i, j)
                    For isb = 1 To Nstress
                        Spoint(i, isb) = Spoint(i, isb) + b1 * Sgaus(j, isb)
                    Next isb
                Next j
            Next i

            For ii = 1 To nmax
                i = NNelem(ie, ii)
                Nw(i) = Nw(i) + 1
                For isb = 1 To Nstress
                    Tp(i, isb) = Tp(i, isb) + Spoint(ii, isb)
                Next isb
            Next ii
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub StressMain(ByVal sx As Single, ByVal sy As Single, _
        ByVal sz As Single, ByVal txy As Single, ByVal tyz As Single, _
        ByVal tzx As Single, ByRef sm1 As Single, ByRef sm2 As Single, _
        ByRef tmax As Single, ByRef sm As Single)
        '主応力の計算
        'sx,sy,sz･･･σx,σy,σz
        'txy,tyz,tzx･･･τxy,τyz,τzx
        'sm1,sm2,tmax,sm･･･σmax,σmin,τmax,σmises

        Dim k As Integer
        Dim b1, b2, b3, s1, s2, sb, smax, smin As Single
        Dim x1, x2, xb, xleft, xright As Single
        Dim cbuf(2) As Single

        cbuf(2) = -(sx + sy + sz)
        b1 = sx * sy + sy * sz + sz * sx
        b2 = txy * txy + tyz * tyz + tzx * tzx
        cbuf(1) = b1 - b2
        b1 = sx * sy * sz
        b2 = sx * tyz * tyz + sy * tzx * tzx + sz * txy * txy
        b3 = 2 * txy * tyz * tzx
        cbuf(0) = -(b1 - b2 + b3)
        b1 = cbuf(2) ^ 2 - 3 * cbuf(1)
        b2 = Math.Sqrt(b1)
        x1 = (-cbuf(2) - b2) / 3    '下側の極大点
        x2 = (-cbuf(2) + b2) / 3    '上側の極小点
        smax = sx : smin = sx
        For k = 1 To 5
            Select Case k
                Case 1
                    sb = sy
                Case 2
                    sb = sz
                Case 3
                    sb = txy
                Case 4
                    sb = tyz
                Case 5
                    sb = tzx
            End Select
            If sb > smax Then
                smax = sb
            ElseIf sb < smin Then
                smin = sb
            End If
            If k = 2 Then
                s1 = smin
                s2 = smax
            End If
        Next k
        b1 = smax - smin
        xb = x2
        xleft = x2
        xright = x2 + b1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        sm1 = xb
        xb = x1
        xleft = x1 - b1
        xright = x1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        sm2 = xb
        tmax = 0.5 * (sm1 - sm2)

        'ﾐｰｾﾞｽ応力の計算
        b1 = 0.5 * ((sx - sy) ^ 2 + (sy - sz) ^ 2 + (sz - sx) ^ 2)
        b1 = b1 + 3 * (txy ^ 2 + tyz ^ 2 + tzx ^ 2)
        sm = Math.Sqrt(b1)

    End Sub

    Private Sub TfVecClear(ByVal nx As Integer)
        'Tfﾍﾞｸﾄﾙのｸﾘｱ
        'nx･･･次数
        Dim i As Integer
        For i = 1 To nx
            TfD(i) = 0
        Next i

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TKmatSet()
        'TK行列設定
        Dim i, ii As Integer
        Dim b1, b2 As Single

        For i = 1 To NumEff
            Tk(i) = 0
        Next i
        b1 = 0.5 * DTime
        b2 = Beta * DTime * DTime
        For i = 1 To NumEff
            Tk(i) = b2 * RKmatb(i)
            If KindVEqua = 1 Then
                If KindDamp = 0 Or Ndamp > 0 Then
                    Tk(i) = Tk(i) + b1 * Cmatb(i)
                End If
            End If
        Next i
        For i = 1 To Norder
            Tk(Idiag(i)) = Tk(Idiag(i)) + RMmatb(i)
        Next i
        If KindVEqua = 1 Then
            If KindDamp = 1 And Ndamp = 0 Then
                For i = 1 To Norder
                    ii = Idiag(i)
                    Tk(ii) = Tk(ii) + b1 * Cmatb(ii)
                Next i

            End If
        End If

    End Sub

    Private Sub FEM3VRCal4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, ib, iconv, icount, id, ie, ik, iLtime As Integer
        Dim istep, j, jb, k, kb, kh, mb, mbx, nx As Integer
        Dim b1, dteps, ej, freemem, rmesh, rmeshmax, rnu, sec, ub As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）
        aa$ = "計算開始" + "   " + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitBase()         '初期ﾍﾞｰｽ設定
        Mband = mb

        aa$ = "初期設定  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Call InitialSet2S(mb)  '初期設定2

        If KindSLoad > 0 Then
            Call InitialLoad()  '初期荷重
        End If

        aa$ = "解析要素計算  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        kb = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie, 0, kb, ej, rnu)     '要素ﾏﾄﾘｯｸｽの計算
            Call StoreS()                           '全体ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If Nspring > 0 Then
            Call SpringSet()    'ﾊﾞﾈ支持の設定
        End If

        For i = 1 To NumEff
            RKmatb(i) = Tk(i)
        Next i

        If KindSLoad > 0 Then
            For i = 1 To NBvar
                k = Lcomp(KBfix(i))
                If k > 0 Then
                    ub = VBfix(i)
                    Call RestCond(k, mb, Neff, ub)    '拘束条件処理
                End If
            Next i

            Call Solver1(Neff)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb, Neff)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            '節点変位の保存（元の節点順）
            For i = 1 To Npoint
                jb = Ndim * (i - 1)
                j = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    kb = jb + id
                    k = j + id
                    TfS(kb) = TfD(Lcomp(k))
                Next id
            Next i
        Else
            If Kboundfree = 0 Then
                '固定節点変位の保存（元の節点順）
                For ib = 1 To Nbound
                    j = Ndim * (Nrest(ib) - 1)
                    For id = 1 To Ndim
                        If Jdirect(ib, id) > 0 Then
                            ub = Vdirect(ib, id)
                            k = j + id
                            TfS(k) = ub
                        End If
                    Next id
                Next ib
            End If
        End If

        Application.DoEvents()
        aa$ = "動解析初期設定  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Call InitialSet1()  '初期設定

        Call InitialSet2()  '初期設定2

        Call MmatSet()          'Ｍ行列の設定

        If KindVEqua > 0 Then
            Call CmatSet()      'Ｃ行列の設定
        End If

        Call MatMaxCalc()       '行列要素の最大値計算  

        Call ResFile1U(mb)       '結果ﾌｧｲﾙへの出力1

        ReDim FLoadVib(NPvib, 3), FLoadVibI(NPvib, 3), FLoadVibX(NPvib, 3)
        Beta = 0.25
        nx = Norder
        ReDim Accel1(nx), Accel2(nx), Disp1(nx), Disp2(nx), Vel1(nx), Vel2(nx)

        Application.DoEvents()
        aa$ = "動解析開始  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        iconv = 0
        KVibOff = 0
        If KindLvib = 1 Then
            Call AccelPointSet()     '加速度加振点の設定
        End If
        If KAnal = 0 Then
            dteps = 0.01 * DTime
            TimeNew = 0
            istep = 0
            iLtime = 0
            kh = 0
            Do
                Dim date1 As Date = Now
                Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
                If istep = 0 Then
                    Call LoadVibNew(kh, iLtime)   '振動外力区間の新規設定
                End If
                kb = istep Mod NstepF
                If kb = 0 And kh = 0 Then
                    For i = 1 To NPvib
                        For j = 1 To 3
                            FLoadVibI(i, j) = FLoadVib(i, j)
                        Next j
                    Next i
                    Call LoadVibNew(kh, iLtime)   '振動外力区間の新規設定
                End If
                If istep = 0 Then
                    If KindLvib = 0 Then
                        Call AccelInit()    '初期加速度の計算
                    End If
                End If
                If kh > -2 Then
                    Call LoadVibSet(kh, KindLvib, istep, NstepF) '振動外力の設定
                End If

                If istep > 0 Then
                    Call AccelCalc(mb)    '加速度の計算
                    Call DispCalc()     '変位の計算
                End If

                kb = istep Mod Nstep
                If istep = 0 Or kb = 0 Then
                    Call StressCalc()   '応力の計算
                    Call RoundTreat(KindTime, NbTime, TimeNew)  '丸め処理
                    Call ResFile2(kh, istep) '結果ﾌｧｲﾙへの出力2
                    kb = -1
                End If
                If TimeNew >= TimeMax Then
                    If kb >= 0 Then
                        Call RoundTreat(KindTime, NbTime, TimeNew)  '丸め処理
                        Call ResFile2(kh, istep) '結果ﾌｧｲﾙへの出力2
                    End If
                    Exit Do
                Else
                    '進行表示
                    aa$ = "ｽﾃｯﾌﾟ" + Str$(istep) + " 終了  "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    ProgressBar1.Value = 100 * TimeNew / TimeMax
                    If istep > 1 Then
                        rmesh = TimeMax / DTime - istep
                        Dim date2 As Date = Now
                        sec = TimeLap(date1, date2)
                        Call ReqTime(1.0, rmesh, sec)   '残りの所要時間の計算
                    End If

                    istep = istep + 1
                    TimeNew = istep * DTime
                    If TimeNew + dteps > TimeMax Then
                        TimeNew = TimeMax
                    End If
                    Call NewStep(nx) '新ｽﾃｯﾌﾟ準備
                End If
                Application.DoEvents()
            Loop
        Else
            DTime = 1 / FreqLVib / NdivCyc
            ReDim Accel0(nx), Disp0(nx), Vel0(nx)
            rmesh = (NKmax + 1) * NdivCyc
            rmeshmax = rmesh
            Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
            Call LoadVibSet2(KindLvib, 0)  '振動外力の設定2
            If KindLvib = 0 Then
                Call AccelInit()    '初期加速度の計算
            End If
            For i = 1 To nx
                Accel1(i) = Accel2(i)
                Disp1(i) = Disp2(i)
                Vel1(i) = Vel2(i)
                Accel0(i) = Accel2(i)
                Disp0(i) = Disp2(i)
                Vel0(i) = Vel2(i)
            Next i
            For ik = 1 To NKmax + 1
                DeltaMax = 0
                For istep = 1 To NdivCyc
                    Dim date1 As Date = Now
                    Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
                    Call LoadVibSet2(KindLvib, istep) '振動外力の設定2
                    Call AccelCalc(mb)    '加速度の計算
                    Call DispCalc()     '変位の計算

                    Call DispCheck()    '変位のﾁｪｯｸ

                    If iconv > 0 Then
                        Call StressCalc()   '応力の計算
                        Call ResFile2(0, istep) '結果ﾌｧｲﾙへの出力2
                    End If

                    If istep = NdivCyc Then
                        If ik > 1 Or iconv > 0 Then
                            If iconv > 0 Then
                                Call ConvResult(iconv, ik) '収束結果の出力
                                iconv = 2
                            Else
                                b1 = Math.Abs(DeltaMax - DeltaMaxb)
                                If DeltaMax = 0 And b1 = 0 Then
                                    iconv = 3
                                    Exit For
                                End If
                                If ik > 5 And b1 < DeltaMax * EpsCalc Then
                                    Call ConvResult(iconv, ik) '収束結果の出力
                                    Call InitAdjust(nx) '初期値調整
                                    Call StressCalc()   '応力の計算
                                    TimeNew = 0
                                    Call ResFile2(0, 0) '結果ﾌｧｲﾙへの出力2
                                    iconv = 1
                                    rmesh = NdivCyc + 1
                                    rmeshmax = rmesh
                                End If
                            End If
                        End If
                        DeltaMaxb = DeltaMax
                        If iconv = 0 Then
                            Call InitAdjust(nx) '初期値調整
                        End If
                    End If
                    '進行表示
                    aa$ = "ik=" + Str$(ik) + " istep=" + Str(istep) + " 終了  "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    rmesh = rmesh - 1
                    ProgressBar1.Value = 100 * (rmeshmax - rmesh) / rmeshmax
                    Dim date2 As Date = Now
                    sec = TimeLap(date1, date2)
                    Call ReqTime(1.0, rmesh, sec)   '残りの所要時間の計算
                    If iconv = 1 Then
                        TimeNew = TimeNew + DTime
                    End If
                    Call NewStep(nx) '新ｽﾃｯﾌﾟ準備
                    Application.DoEvents()
                Next istep
                If iconv > 1 Then
                    Exit For
                End If
            Next ik
        End If

        aa$ = "ｽﾃｯﾌﾟ計算終了   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If iconv < 3 Then
            Call ResFile3(iconv)     '結果ﾌｧｲﾙへの出力3
        End If

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)
        SwK.Close()

        Label3.Text = aa$

        Label1.Text = "計算終了！"
        If KAnal = 0 Or iconv = 2 Then
            Label2.Text = "計算結果をファイルへ出力しました。"
            aa$ = "計算が終了しました。"
            aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        Else
            Label2.Text = "計算結果は出力されませんでした。"
            Select Case iconv
                Case 0
                    aa$ = "収束しませんでした！"
                Case 1
                    aa$ = "収束しましたが、計算回数不足です！"
                Case 3
                    aa$ = "変位が0のままです！"
            End Select
        End If
        Me.BringToFront()
        If KindBatch = 0 Then
            MsgBox(aa$, 0, "計算確認")
        Else
            Kfinish = 1
        End If
        gr.Dispose()

        Me.Close()

    End Sub

End Class
